// ##############################################################################################################
//
//		silverlight.js
//
//			bentigt bereits geladene GrandPiano.js
//
//			In dieser JS-Datei sind
//				nur Daten und Routinen kodiert, die 
//						intern fr Silverlight verwendet werden
//						folgende Daten aus GrandPiano.js lesend benutzen
//							X1_SilverlightControl_Version
//							X1_SilverlightControlHost_ID
//							X1_Daten_OBJECT_ElementeBezeichner
//							X1_Daten_PARAM_ElementeBezeichner
//							X1_Silverlight_DatenElementeBezeichner
//							X1_Silverlight_DatenElementeBezeichner_parentElement_Index
//							X1_Silverlight_DatenElementeBezeichner_events_Index
//							X1_Silverlight_DatenElementeBezeichner_onError_Index
//							X1_Silverlight_DatenElementeBezeichner_onLoad_Index
//							X1_SilverlightDaten
//							X1_GrandPiano
//				KEINE Daten und Routinen des X1_GrandPiano kodiert (siehe dafr NUR GrandPiano.js)
//
//			aufbereitete JS-Datei anhand der Programmcode der Microsoft-programmierten JS-Dateien
//							silverlight.js
//							createsilverlight.js
//			Aufbereitung
//				erfolgt damit 	Quelltext lesbar wird
//						 	Programmlogik erkennbar wird
//				mit Entfernung aller Logik- und Programmierungsfehler, die von Microsoft eingebaut wurden
//			Sollte Der Internet Exlorer mit Start der index.html regelmig einen Adressfehler bringen,
//						der auch die Adresse 0x00000000 umfassen kann, ist das Silverlight-ActiveX-Control
//						defekt und es muss neu installiert werden: Dazu lade man sich die aktuellen Updates
//							zum IE per http://msdn2.microsoft.com/en-us/library/bb188743.aspx
//							zu Silverlight per http://silverlight.net/Default.aspx
//						herunter und installiere diese. Man beachte Nicht-Kompatibitt von
//						Silverlight-Varianten (inkl. deren Beta-Versionen).
//			WARNUNG: Microsoft zeigt mit seiner JS-Datei, wie man NICHT prorgrammieren sollte:
//						Es werden Daten und Programmcode munter gemixt, so dass der
//							Quellcode nur als wertlose Einzelfall-Lsung dient.
//						Silverlight wird datenseitig konsequent NICHT dynamisch programmiert:
//							Daten liegen teilweise als Programmcode-Teile vor und zwar derart
//								festkodiert, dass deren Kapselung eine vllig andere Programmlogik
//								erzwingt, die aber Voraussetzung fr dynamische Webseiten mit
//								geringem Pflegeaufwand ist.
//						   Microsoft zeigt mit der Einzelfall-Lsung, dass die Programmierung mit
//								Silverlight nicht jedermanns Sache bei Microsoft ist.
//						   Es werden Konzeptfehler on Silverlight sichtbar: Daten und Programmcode 
//								der Anwendung sind von denen, die das Silverlight-Laufzeitsystem bentigt,
//								nur schwer trennbar, so dass deren Verqickung IMMER eine Einzelfalllsung
//								darstellt, wenn nicht gengend Programmierungsaufwand betrieben wird.
//							Mit anderen Worten: Es muss zwingend geprft werden, ob Trennung mglich
//								ist: Wenn nein, sollte das Projekt mit anderer Laufzeitumgebung als 
//								Silverlight geschrieben werden: Einzellsungen sind meist supportaufwendig
//								und die Kinderkrankheiten des programmierten Silverlight-Konzpetes
//								sind genau genommen einfach nur Mll - und das als Aushngeschild per
//								Grand-Piano mit Microsoft-Signatur.
//						Faulheiten des Programmieres fhrt zu uneinheitlichem Quelltext als Einzellsung:
//							Die Verwendung von Variablennamen ist Elend pur und gleicht dem von Anfngern.
//							Wegen Faulheit werden beim Codieren werden Anweisungen verwendet, deren
//								Komplexitt mehr Laufzeit kostet, als bei Verwendung einfacher
//								Anweisungen.
//							Vorgaben von Microsoft zur Quelltext-Optimierung im Sinne der
//								Script-Laufzeit-Optimierung werden konsequent ignoriert.
//				Die Aufarbeitung des Quellcode zeigt Anstze, wo dynamische Programmierung
//						notwendig und sinnvoll ist, ersetzt aber die vom Microsoft-Programmierer
//						verwendete Logik nicht komplett (aus Mist lsst sich kein Gold machen),
//						da ansonsten die Anwendung komplett neu programmiert werden msste.
//						Die Verwendung von HTTPRequest zur Daten- und Script-Programmcode-Beschaffung
//						zur Laufzeit ist nicht eingebaut worden, empfiehlt sich aber.
//				Die Routinen sollten mglichst als eigenstndiges System unabhngig von Zeigern von Silverlight
//						programmiert werden und ber Silverlight-Variablen bzw. -Zeiger referenziert werden
//						(z.B. Zeiger auf Funktion kopieren nach Silverlight-Funktionsvariable).
//						Silverlight wird von Microsoft permanent verndert und
//						Schnittstellenkonsistenz ist Sache von Microsoft: Werden Schnittstellen verndert,
//						so sind wenigstens die Routinen als System unberhrt und der Fehler ist schneller
//						findbar.
//			Microsoft will anhand Silverlight seine (sau teueren) Developer-Produkte wie Visual
//			und Co. verkaufen (Testversionen sind zeitlich limitiert) und zugleich ASP 
//			in die Adobe-Flash-Konkurrenz drcken - allerdings ist das mehr ein Eigentor.
//			Alternativen zur Silverlight-Technik gabs schon seit 1998 (also rechtzeitig VOR Adobe Flash
//			und als Betriebsystemkomponenten, auf die u.a. auch Office-Powerpoint aufbaute (bis hin zur
//			Timeline-Programmierung per HTML, JavaScript oder VBasic) in DirectX mit Direct3D und DirectMedia
//			(inklusive HTML- und Javascript-Schnittstelle + kostenlosem SDK fr Web-Desing), die aber 
//			inzwischen von Microsoft ersatzlos und gnadenlos entfernt wurden (u.a. mit der Begrndung,
//			dass neueres Windows neuere und sichere Schnittstellen bentigt). Die Abschaltung ist allerdings
//			ganz klar ein Analogon zum Wechsel des Treibersystems zwischen Win XP SP1 und 2 sowie erneut von
//			Win XP zu Win Vista (verbunden mit Folgekosten (abgesehen von Hardwarekosten): User, die weiterhin
//			Schnittstellen fr Webseiten mit Animation auf DirectX-Basis nutzen wollen, werden gnadenlos vom Markt
//			gefegt: Sie mssen umstellen (und so auch Developer-Produkte kaufen) oder zur Konkurrenz wechseln,
//			denn ein hherer Programmierungsaufwand lohnt nur bei dauerhafteren Schnittstellensystemen).
//			DirectX wurde gezielt nicht mehr abwrtskompatibel gehalten, da zustzlich Net-Framework durchgedrckt
//			werden soll (Pendant zu Sun Java): Silverlight + DirectX mit Net-Framework sollen zusammenarbeiten - 
//			mglichst mit ASP und das mit Browsern wie Safari oder Firefox. (Net-Framwork ist in Versionen parallel
//			installierbar, Silverlight jedoch nicht).
//
//
// Smtliche Entwicklungstools der Express-Serie (Blend, Media etc.) gibt es
//	als Trial fr einen begrenzem Laufzeitraum und sind ansonsten zu kaufen.
//
//  Microsoft Expression Blend Free Trial
//
//		We are pleased to present a trial version of Microsoft Expression Blend. 
//		This fully functioning version will expire 60 days after installation. 
//		This trial can be unlocked when you receive your purchased copy of the 
//		product by entering the product key found on the box.
//
//		Die Vollversion kostet 600 US-Dollar
//
// Microsoft Expression Studio (Free evaluation is available for download)
//
//	ist als Trial in Komponenten zerlegt, die verschiedene Laufzeiten haben
//		z.B.
//
//		  	Microsoft Expression Blend Free Trial
//
//			We are pleased to present a trial version of Microsoft Expression Blend. 
//			This fully functioning version will expire 60 days after installation. 
//			This trial can be unlocked when you receive your purchased copy of the 
//			product by entering the product key found on the box.
//
//
//	Whether creating standards-based Web user interfaces by using Microsoft ASP.NET, 
//		building cross-platform rich interactive applications with Silverlight, 
//		or creating ultimate Windows Vista experiences with Windows Presentation 
//		Foundation (WPF), Expression tools enable designers to fully apply their 
//		creativity while collaborating with developers using Microsoft Visual Studio. 
//		Expression Studio includes the following products:
//			Expression Web for building standards-based Web sites.
//			Expression Design for professional illustration and graphic design.
//			Expression Blend for creating engaging Web-connected experiences for Microsoft Windows. 
//			This special preview version is compatible with creating content for Silverlight 1.0 
//				Release Candidate and Silverlight 1.1 Alpha.
//			Expression Media for assets management as well as media encoding. 
//				This version also includes the Expression Encoder tool for transcoding video content. 
//
//
//   Windows Movie Maker
//
//
//	Import audio and video to your computer from a digital video camera, and then use the 
//	imported content in your movies. You can also import existing audio, video, or still 
//	pictures into Windows Movie Maker to use in the movies you create. After editing the audio 
//	and video content in Windows Movie Maker, which can include adding titles, transitions, 
//	or effects, you can then publish your final movie and share it with your friends and family. 
//	Windows Movie Maker is also available for Microsoft Windows XP.
//
//
// ################################################################################################################



// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			anzupassende GLOBALE Daten
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//  Es gibt noch Daten, die direkt in Routinen kodiert sind und dort im Kontext der Routine anzupassen sind
//		siehe Y_SilverlightOnlineInstallControl_HTMLCode_ermitteln()
//			Y_Silverlight_EventHandler_Standard()

var X_SilverlightDownloadUrl='http://go.microsoft.com/fwlink/?LinkID=';

var X_SilverlightMimeTypeAttribut=' TYPE="application/x-silverlight"';
var X_Silverlight_Kennung_ActiveX='AgControl.AgControl';
var X_Silverlight_Kennung_PlugIn='Silverlight Plug-In';  	// laut navigator.plugins
										  // nicht relevant fr MS Internet Explorer, da der
										  //		ActiveX nutzt und kein Plugin

var X_SilverlightControl_IFrameTag='<IFRAME STYLE="visibility:hidden;height:0;width:0"></IFRAME>';

var X_SilverlightControl_EMBED_Tag1='<EMBED';
var X_SilverlightControl_EMBED_Tag2='></EMBED>';
var X_SilverlightControl_EMBED_Tag3=  X_SilverlightControl_EMBED_Tag1 
						+ X_SilverlightMimeTypeAttribut
						+ X_SilverlightControl_EMBED_Tag2;

var X_SilverlightControl_OBJECT_Tag1='<OBJECT DATA="data:,"';
var X_SilverlightControl_OBJECT_Tag2='</OBJECT>';
var X_SilverlightControl_OBJECT_Tag3=  X_SilverlightControl_OBJECT_Tag1
						 + X_SilverlightMimeTypeAttribut
						 + '>' 
						 + X_SilverlightControl_OBJECT_Tag2;

var X_SilverlightControl_PARAM_Tag1='<PARAM NAME="';
var X_SilverlightControl_PARAM_Tag2='" VALUE="';
var X_SilverlightControl_PARAM_Tag3='"></PARAM>';


// +++++ Daten zu Betriebssystemen, die von Silverlight untersttzt werden ++++++++++++++++++++++++++++++++++++++
//	    alle Datenfelder sind indexsynchron und drfen nicht leer sein !


var X_KennzeichenFeld_SupportedBetriebssystem = new Array 
(// Kennung laut navigator.userAgent
 // z.B. Microsoft Internet Explorer 6 unter Windows XP liefert
 //		"Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)"
 // z.B. Microsoft Internet Explorer 7 unter Windows XP SP2 liefert
 //		"Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; ......)"	wobei ...... hier weglassung bedeutet
 "Windows NT",								// Kennung bei Win32 und Win64 
 "PPC Mac OS X",
 "Intel Mac OS X"
);

var X_KennzeichenFeld_EingeschraenktSupportedBetriebssystem = new Array  
(// Kennung laut navigator.userAgent
 "Win64",									// kein Win64
 "",										// es gibt keine Einschrnkung
 ""										// es gibt keine Einschrnkung
);

var X_TitelFeld_SupportedBetriebssystem = new Array
("Windows",
 "MacPPC",
 "MacIntel"
);


// +++++ Daten zu Browsern, die von Silverlight untersttzt werden ++++++++++++++++++++++++++++++++++++++++++++++
//	    alle Datenfelder sind indexsynchron und drfen nicht leer sein !

var X_Index_MSIE_SupportedBrowser=0;				// Index von Internet Explorer in nachfolgenden Feldern
var X_Index_Firefox_SupportedBrowser=1;				// Index von Firefox in nachfolgenden Feldern
var X_Index_Safari_SupportedBrowser=2;				// Index von Safari in nachfolgenden Feldern
var X_Index_Opera_SupportedBrowser=3;				// Index von Opera in nachfolgenden Feldern

var X_Titel_SupportedBrowser = new Array
(// Kennung laut navigator.userAgent aber ohne Sonderzeichen "/" (falls vorhanden)
 "MSIE",
 "Firefox",
 "Safari",
 "Opera"
);

var X_Kennung_SupportedBrowser = new Array
(// Kennung laut navigator.userAgent mit Sonderzeichen "/" (falls vorhanden)
 X_Titel_SupportedBrowser[X_Index_MSIE_SupportedBrowser],
 X_Titel_SupportedBrowser[X_Index_Firefox_SupportedBrowser] + '/',
										// z.B. "Firefox/2.5"
 X_Titel_SupportedBrowser[X_Index_Safari_SupportedBrowser],
 X_Titel_SupportedBrowser[X_Index_Opera_SupportedBrowser] + '/'					
										// z.B. "Opera/2.5"
);

 var X_Hauptversion_SupportedBrowser = new Array			// 0 bedeutet immer supported
(// Kennung laut navigator.userAgent
 6,
 2,										// Achtung: ab Firefox 1.5 ist zwar mglich,
										//			aber geprft erst ab 2.x
 0,
 99										// diese Versionsnummer gibt es niemals
										//		damit ist der Browser nicht supported
);

var X_Unterversion_SupportedBrowser = new Array	// 0 bedeutet immer supported)
(// Kennung laut navigator.userAgent
 0,
 0,										// Achtung: ab Firefox 1.5 ist zwar mglich,
										//			aber geprft erst ab 2.x
 0,
 0
);

var X_SilverlightTestControl_Art_SupportedBrowser = new Array
(1,										//	ActiveXControl
 0,										//    kein ActiveXControl
 0,										//    kein ActiveXControl
 0 										//    kein ActiveXControl
);

var X_SilverlightTestControl_HTMLCode_SupportedBrowser = new Array
(X_Silverlight_Kennung_ActiveX,
 X_SilverlightControl_EMBED_Tag3,
 X_SilverlightControl_OBJECT_Tag3,
 X_SilverlightControl_EMBED_Tag3
);

var X_SilverlightTestControl_PluginAxtivexKennung_SupportedBrowser = new Array
(X_Silverlight_Kennung_ActiveX,					// ActiveX und kein Plugin
 X_Silverlight_Kennung_PlugIn,  					// laut navigator.plugins
 X_Silverlight_Kennung_PlugIn,  					// laut navigator.plugins
 X_Silverlight_Kennung_PlugIn  					// laut navigator.plugins
);

// ++++++ Kombinationen von Betriebssystem und Browser, die nicht erlaubt sind ++++++++++++++++++++++++++++++++++
//	    nachfolgende Felder sind index-synchron
//                            knnen leer sein

var X_Index_Windows_SupportedBetriebssystem=0;			// Index von Windows in nachfolgenden Feldern
var X_Index_MacPPC_SupportedBetriebssystem=1;			// Index von MacPPC in nachfolgenden Feldern
var X_Index_MacIntel_SupportedBetriebssystem=2;			// Index von MacIntel in nachfolgenden Feldern

var X_UnerlaubteKombination_TitelFeld_SupportedBetriebssystem=new Array
(X_Index_Windows_SupportedBetriebssystem,				// Windows
 X_Index_MacPPC_SupportedBetriebssystem,				// MacPPC
 X_Index_MacIntel_SupportedBetriebssystem				// MacIntel
);

var X_UnerlaubteKombination_TitelFeld_SupportedBrowser=new Array
(X_Index_Safari_SupportedBrowser,					// Safari
 X_Index_MSIE_SupportedBrowser,					// Internet Explorer
 X_Index_MSIE_SupportedBrowser					// Internet Explorer
);


// ++++++ sonstiges +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
var X_Kennzeichen_NichtSupported="Unsupported";
var X_VersionsNummerTrenner='.';
//       Achtung: window.navigator.userAgent muss Zeichenkette enthalten in der Form "wxyz"
//				wobei w 	laut X_Kennung_SupportedBrowser		z.B.  "Firefox/"
//					x 	fr Hauptversion als Ziffer				z.B.  "2"  oder "20"
//					y   	laut X_VersionsNummerTrenner  			z.B. "."
//					z 	fr Unterversion als Ziffer				z.B.  "5"  oder "25"
//				Die Syntax wird NUR dann geprft, wenn erkannter Browser 
//					mit Kennung laut navigator.userAgent in X_Kennung_SupportedBrowser hinterlegt ist
//                       und Hauptversionsummer > 0 in X_Hauptversion_SupportedBrowser.
//                     Ein Browser, dessen Kennung laut navigator.userAgent  nicht enthalten ist in
//								     in  X_Kennung_SupportedBrowser
//					gilt automatisch als nicht supported !

var X_WindowEventhandler_Load_Kennung="__slLoad";
var X_WindowEventhandler_Error_Kennung="__slError";
var X_FehlerKennung_ParserError="ParserError";
var X_FehlerKennung_RuntimeError="RuntimeError";


//  Es gibt noch Daten, die direkt in Routinen kodiert sind und dort im Kontext der Routine anzupassen sind
//		siehe Y_SilverlightOnlineInstallControl_HTMLCode_ermitteln()
//			Y_Silverlight_EventHandler_Standard()


// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			interne Daten, nicht ndern
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			HTML-Code zusammenbauen
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// ++++++ HTML-Code des Silverlight-Control ermitteln +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function Y_SilverlightControl_HTMLCode_ermitteln(X_Daten_OBJECT, X_Daten_PARAM) 
// bentigt gefllt X_SilverlightEinsetzbar  true so Silverligth einsetzbar
//                  Silverlight.ua
// Routine MUSS manuell aktualisiert werden bezglich HTML-Code fr Browser (siehe X_Flag)
{var X_Kette1='';
 var X_Kette2='';
 var X_Kette3='';
 var X_Kette4='';
 var X_Index;
 var X_Flag=false;

 // ++++++ prfen ob Silverlight einsetzbar ist
 if(X_SilverlightEinsetzbar)
 {// +++++ ermitteln ob Safari benutzt wird
  X_Flag=(Silverlight.ua.Browser == X_Titel_SupportedBrowser[X_Index_Safari_SupportedBrowser]);
  
  // +++++ Silverlight-Control-HTML-Code zusammenbauen
  X_Kette1='';

  // ----- Beginn-Tag Teil 1 OBJECT-Einleitung
  X_Kette2=X_SilverlightControl_OBJECT_Tag1;
  if(X_Flag){X_Kette2=X_SilverlightControl_EMBED_Tag1;}	// Safari
  X_Kette1+=X_Kette2;

  // ----- Beginn-Tag Teil 2 Attribut TYPE
  X_Kette1+=X_SilverlightMimeTypeAttribut;	// Mime-Typ TYPE

  // ----- Beginn-Tag Teil 3 restliche Attribute laut Elemente 0 bis 2 in X1_Daten_OBJECT_ElementeBezeichner
  for(X_Index=0;X_Index<3;X_Index++)
  {X_Kette2=Y_ZeichenZuUniCode(X1_Daten_OBJECT_ElementeBezeichner[X_Index]);	
										// Bezeichner des Datenelementes holen
   X_Kette3=Y_ZeichenZuUniCode(X_Daten_OBJECT[X_Kette2]);	// Wert des Datenelementes holen
   X_Kette1+=(' ' + X_Kette2 + '="' + X_Kette3 + '"');
								// Hinweis: X_Daten_OBJECT.name ist identisch mit X_Daten_OBJECT[name]
								//			wobei name ein String ist, der den Bezeichner des
								//				Datenlementes enthlt (und keine Punktnotation
								//				enthltt, da jeder Punkt einen Unter-Index anzeigt).
  }

  // ----- Beginn-Tag Teil 4 OBJECT-Ende
  X_Kette2='>';
  if(X_Flag){X_Kette2='';}				// Safari
  X_Kette1+=X_Kette2;

  // ----- PARAM's  im OBJECT
  X_Kette2=X_SilverlightControl_PARAM_Tag1;
  X_Kette3=X_SilverlightControl_PARAM_Tag2;
  X_Kette4=X_SilverlightControl_PARAM_Tag3;
  if(X_Flag)						// Safari
  {X_Kette2= ' ';
   X_Kette3= '="';
   X_Kette4= '"';
  }
  for(X_Index in X_Daten_PARAM)			// Daten PARAM abklappern
  {if(X_Daten_PARAM[X_Index])
   {X_Kette1+=(  X_Kette2 + Y_ZeichenZuUniCode(X_Index) 
               + X_Kette3 + Y_ZeichenZuUniCode(X_Daten_PARAM[X_Index]) 
               + X_Kette4
              );						// Hinweis: X_Daten_PARAM[X_Index]  ist identisch mit X_Daten_PARAM.X_Index
								//			wobei X_Index ein String ist, der den Bezeichner des
								//				Datenlementes enthlt (und keine Punktnotation
								//				enthltt, da jeder Punkt einen Unter-Index anzeigt).
   }
  }

  // ----- Ende-Tag des OBJECT
  X_Kette2=X_SilverlightControl_OBJECT_Tag2;
  if(X_Flag)						// Safari
  {X_Kette2=  X_SilverlightControl_EMBED_Tag2
            + X_SilverlightControl_IFrameTag;
  }
  X_Kette1+=X_Kette2;

  alert('HTML-Code des Silverlight-HTML-Objektes:\n\n' + X_Kette1);

  return X_Kette1;
 }
};

// +++++ HTML-Code des Silverlight-Online-Install-Controls erzeugen +++++++++++++++++++++++++++++++++++++++++++++
function Y_SilverlightOnlineInstallControl_HTMLCode_ermitteln(X_Daten) 
// bentigt gefllt X_SilverlightEinsetzbar  true so Silverligth einsetzbar
//                  Silverlight.ua
// Routine MUSS manuell aktualisiert werden bezglich
//    Abfrage auf X_TitelFeld_SupportedBetriebssystem[] je nach Browser
//    Aktualisierung der LinkID-Ziffernfolgen 9xxxxx    je nach Browser
{var X_TextFeld=new Array
 ('Microsoft Silverlight erhalten',
  'Mit Klicken',
  'akzeptieren Sie da',
  'Silverlight License Agreement',
  'Silverlight startet automatisch, ',
  'Silverlight Privacy Statement',
  'Mehr erfahren'
 );
 var b="92822";
 var e='';
 var m="0x409";
 var n='';
 var i='';
 var h='';
 var g='';
 var k='';
 var X_DownloadUrl_Root=Silverlight.fwlinkRoot;
 var X_OS=Silverlight.ua.OS;
 var X_DownloadLink_HTMLCode='';

 // ++++++ prfen ob Silverlight einsetzbar ist
 if(X_SilverlightEinsetzbar)
 {if(X_Daten.inplaceInstallPrompt) 
  {n="98109";
   if(Silverlight.available)
   {e="96189";
    i="96422"
   }
   else
   {e="96188";
    i="96422";
   }
   h="93481";
   g="93483";
   if(X_OS==X_TitelFeld_SupportedBetriebssystem[X_Index_Windows_SupportedBetriebssystem])
   {b="92799";
    h="92803";
    g="92805";
   }
   else
   {if(X_OS==X_TitelFeld_SupportedBetriebssystem[X_Index_MacIntel_SupportedBetriebssystem])
    {b="92808";
     h="92804";
     g="92806";
    }
    else
    {if(X_OS==X_TitelFeld_SupportedBetriebssystem[X_Index_MacPPC_SupportedBetriebssystem])
     {b="92807";
      h="92815";
      g="92816";
     }
    }
   }  

   X_DownloadLink_HTMLCode =
        '<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="206px">'
      +  '<TR>'
      +   '<TD>'
      +    '<IMG STYLE="display: block; cursor: pointer; '
      +         'BORDER= 0;" '
      +         'TITLE="' + X_TextFeld[1] + '" '
      +         'ALT="'   + X_TextFeld[1] + '" '
      +         ' onclick="javascript:Y_DownloadLink_OnClick({0});" '
      +         'SRC="{1}" '
      +    '>'
      +   '</TD>'
      +  '</TR>'
      +  '<TR>'
      +   '<TD STYLE="width: 206px; '
      +              'margin: 0px; '
      +              'background: #FFFFFF; '
      +              'color: #C7C7C7; '
      +              'border-left-style: solid; '
      +              'border-right-style: solid; '
      +              'border-color: #c7c7bd; '
      +              'border-width: 2px; '
      +              'padding-left: 6px; '
      +              'padding-right: 6px; '
      +              'padding-top: 3px; '
      +              'padding-bottom: 0px; '
      +              'font-size: 55%;'
      +              'font-family: Verdana; '
      +              'text-align: left'
      +             '"'
      +   '>'
      +    X_TextFeld[2]
      +    ' <B>"' + X_TextFeld[1] + '"</B> '
      +    X_TextFeld[3]
      +    '<BR>'
      +    '<A TITLE="' + X_TextFeld[4] + '" '
      +       'HREF="{2}" '
      +       'TARGET="_top" '
      +       'STYLE="text-decoration: underline; color: #96C5E1"'
      +    '>'
      +     '<B>' + X_TextFeld[4] + '</B>'
      +    '</A>';
      +   '</TD>'
      +  '</TR>'
      +  '<TR>'
      +   '<TD>'
      +     '<IMG SRC="{5}" '
      +          'STYLE="border: 0; display: block" '
      +     '>'
      +   '</TD>'
      +  '</TR>'
      +  '<TR>'
      +   '<TD STYLE="width: 206px; '
      +              'margin: 0px; '
      +              'background: #D8EFF9; '
      +              'color: #C7C7C7; '
      +              'border-left-style: solid; '
      +              'border-right-style: solid; '
      +              'border-width: 2px; '
      +              'border-color: #c7c7bd; '
      +              'padding-left: 6px; '
      +              'padding-right: 6px; '
      +              'padding-top: 0px; '
      +              'padding-bottom: 2px; '
      +              'font-family: Verdana; '
      +              'font-size: 55%; '
      +              'text-align: left'
      +             '"'
      +   '>'
      +    X_TextFeld[5]
      +    '<A TITLE="' + X_TextFeld[6] + '" '
      +       'HREF="{3}" '
      +       'TARGET="_top" '
      +       'STYLE="text-decoration: underline; color: #96C5E1"'
      +    '>'
      +     '<B>' + X_TextFeld[7] + '</B>'
      +    '</A>';
      +   '</TD>'
      +  '</TR>'
      +  '<TR>'
      +   '<TD>'
      +    '<IMG ALT="" '
      +         'SRC="{4}" '
      +    '>'
      +   '</TD>'
      +  '</TR>'
      + '</TABLE>';

   X_DownloadLink_HTMLCode = X_DownloadLink_HTMLCode.replace("{2}", X_DownloadUrl_Root + h);
   X_DownloadLink_HTMLCode = X_DownloadLink_HTMLCode.replace("{3}", X_DownloadUrl_Root + g);
   X_DownloadLink_HTMLCode = X_DownloadLink_HTMLCode.replace("{4}", X_DownloadUrl_Root + i);
   X_DownloadLink_HTMLCode = X_DownloadLink_HTMLCode.replace("{5}", X_DownloadUrl_Root + n);
  }
  else
  {if(Silverlight.available){e="94377";}
   else{e="92801";}

   if(X_OS==X_TitelFeld_SupportedBetriebssystem[X_Index_Windows_SupportedBetriebssystem]){b="92800";}
   else
   {if(X_OS==X_TitelFeld_SupportedBetriebssystem[X_Index_MacIntel_SupportedBetriebssystem]){b= "92812";}
    else
    {if(X_OS==X_TitelFeld_SupportedBetriebssystem[X_Index_MacPPC_SupportedBetriebssystem]){b="92811";}}
   }

   X_DownloadLink_HTMLCode =
         '<DIV STYLE="display:block; width: 205px; height: 67px;">'
      +   '<IMG onclick="javascript:Y_DownloadLink_OnClick({0});" '
      +       'STYLE="border:0; cursor:pointer" SRC="{1}" '
      +       'TITLE="' + X_TextFeld[0] + '" '
      +       'ALT="'   + X_TextFeld[0] + '"'
      +   '>'
      +  '</DIV>';
  }
  X_DownloadLink_HTMLCode = X_DownloadLink_HTMLCode.replace("{0}", b);
  X_DownloadLink_HTMLCode = X_DownloadLink_HTMLCode.replace("{1}", X_DownloadUrl_Root + e + "&amp;clcid=" + m);

  return X_DownloadLink_HTMLCode;
 }
};


// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			Event-Handler
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// +++++ Download-Link onClick-Handler ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function Y_DownloadLink_OnClick(a)
{top.location = Silverlight.fwlinkRoot + String(a);}


// +++++ Standard-Error-Handler +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function Y_Silverlight_EventHandler_Standard(e, X_FehlerObjekt) 
// e ist Platzhalter
{// ++++++ nachfolgende Text-Variablen sind anpassbar
 var X_Text='\nSilverlight-Fehlermeldung';
 var X_FehlerKomponenten_TextFeld=new Array	// Indexe sind nicht vernderbar !
  (X_Text,					// 0
   '\nFehler-Code: ',			// 1
   '\nFehler-Typ: ',			// 2
   '\nMeldung: ',				// 3
   '\nim XAML-File: ',			// 4
   '\nin Zeile: ',			// 5
   '\nan Position: ',			// 6
   '\nin Routine: '			// 7
  );
 var X_FehlerMeldungGesamt=X_Text + ': Fehler-Daten nicht verfgbar!';

 // +++++ ab hier nichts ndern !
 if(X_FehlerObjekt!=null)
 {
  var X_FehlerTyp;
  var X_FehlerCode;
  var X_FehlerTyp  = X_FehlerObjekt.ErrorType;
  var X_FehlerZeilenNummer=X_FehlerObjekt.lineNumber;
  var X_FehlerKomponentenFeld=new Array();	// indexsynchron zu X_FehlerKomponenten_TextFeld

  // +++++ Fehlerkomponenten-Feld fllen (indexsynchron zu X_FehlerKomponenten_TextFeld)
  X_FehlerKomponentenFeld[0]='';	// immer Leerkette
  X_FehlerKomponentenFeld[1]=X_FehlerObjekt.ErrorCode;
  X_FehlerKomponentenFeld[2]=X_FehlerTyp;
  X_FehlerKomponentenFeld[3]=X_FehlerObjekt.ErrorMessage;
 
  if(X_FehlerTyp==X_FehlerKennung_ParserError)
  {X_FehlerKomponentenFeld[4]=X_FehlerObjekt.xamlFile;}
  else
  {X_FehlerKomponentenFeld[4]='';
   X_FehlerKomponenten_TextFeld[4]='';
  }

  if(X_FehlerZeilenNummer!=0)
  {X_FehlerKomponentenFeld[5]=X_FehlerZeilenNummer;
   X_FehlerKomponentenFeld[6]=X_FehlerObjekt.charPosition;
  } 
  else
  {X_FehlerKomponentenFeld[5]='';
   X_FehlerKomponentenFeld[6]='';
   X_FehlerKomponentenFeld[5]='';
   X_FehlerKomponentenFeld[6]='';
  }

  if(X_FehlerTyp==X_FehlerKennung_RuntimeError)
  {X_FehlerKomponentenFeld[7]=X_FehlerObjekt.methodName;}
  else
  {X_FehlerKomponentenFeld[7]='';
   X_FehlerKomponenten_TextFeld[7]='';
  }

  // +++++ Fehlermeldungs-Gesamt Text erzeugen
  for(X_Zahler=0;X_Zahler<8;X_Zahler++)
  {X_FehlerMeldungGesamt+=X_FehlerKomponenten_TextFeld[X_Zahler];
   X_FehlerMeldungGesamt+=X_FehlerKomponentenFeld[X_Zahler];
  }
 }

 // +++++ Fehlermeldung-Gesamt anzeigen
 alert(X_FehlerMeldungGesamt);
};

// +++++ Eventhandler entfernen ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function Y_Window_Eventhandler_OnUnLoad()
{var X_Index=0;
 var X_Kette='';
 for(X_Index=Silverlight._silverlightCount-1;X_Index>=0;X_Index--) 
 {X_Kette=X_Index.toString();
  window[X_WindowEventhandler_Load_Kennung  + X_Kette] = null;	// Zeiger des Eventhandler laut Kennung lschen
  window[X_WindowEventhandler_Error_Kennung + X_Kette] = null;	// Zeiger des Eventhandler laut Kennung lschen
 }
 // unload deattachieren beim IE (andere Browser Listener abschalten)
 if(window.removeEventListener)
 {window.removeEventListener("unload", Y_Window_Eventhandler_OnUnLoad, false);}
 else{window.detachEvent("onunload", Y_Window_Eventhandler_OnUnLoad);}
};

// +++++ Zeichenkette nach Unicode durchsuchen und bei Unicode das Zeichen durch '&# ...;' ersetzen
function Y_ZeichenZuUniCode(X_Kette1) 
{var X_UniCode=0;
 var X_Kette2='';
 var X_Zeichen='';
 var X_Laenge=0;
 var X_Index=0;
 if(X_Kette1!=null)
 {X_Laenge=X_Kette1.length;
  if(X_Laenge>0)
  {for(X_Index=0;X_Index<X_Laenge;X_Index++) 
   {X_Zeichen = X_Kette1.charAt(X_Index);						// ASCII-Zeichen holen
    X_UniCode = X_Zeichen.charCodeAt(0);						// Unicode holen
    if(   ((X_UniCode > 43) && (X_UniCode < 58) && (X_UniCode != 47))	// ,-.  und 0 bis 9 jedoch nicht /
       || ((X_UniCode > 64) && (X_UniCode < 91))				// A bis Z
       || (X_UniCode == 95)								// _
       || ((X_UniCode > 96) && (X_UniCode < 123)) 				// a bis z
      ) 
    {X_Kette2+=X_Zeichen;}								// unverndert
    else{X_Kette2+=("&#" + X_UniCode + ";");}					// konvertieren
   }
  }
 }
 return X_Kette2;
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			Silverlight-Einsetzbarkeit ermitteln (Init-Status wird nicht ermittelt)
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// +++++ Verfgbarkeit von Silverlight-ActiveX bzw. -PlugIn ermitteln +++++++++++++++++++++++++++++++++++++++++++
function Y_SilverlightEinsetzbarkeitErmitteln_AufActiveXbzwPluginPruefen(X_Daten_SilverlightControl_Version)
{var X_ReturnWert=false;
 var X_ActiveXControlErzeugen=false;
 var X_TestControl=null;
 var X_DIVContainer=null;
 var X_Zahler=0;
 var X_LaengeFeld=0;
 var X_IndexAufFeld=0;
 var X_ControlArt=0;
 var X_PlugInKennung='';
 var X_TitelBrowser='';
 var X_ControlCode='';

 // +++++ Feld-Index zum erkannten Browser (laut Silverlight.ua.Browser) ermitteln
 X_LaengeFeld=X_Titel_SupportedBrowser.length;
 X_IndexAufFeld=-1;											// Annahme: Index nicht gefunden
 for(X_Zahler=0;X_Zahler<X_LaengeFeld;X_Zahler++)						// Feld der Ttel der Browser abklappern
 {X_TitelBrowser=X_Titel_SupportedBrowser[X_Zahler];					// Titel des Browsers holen
  if(Silverlight.ua.Browser == X_TitelBrowser){X_IndexAufFeld=X_Zahler;}		// 	und mit gemerkten vergleichen
														//   wenn identisch so Index erkannt
 }

 // +++++ Index gefunden ?
 X_ReturnWert=(X_IndexAufFeld>=0);

 if(X_ReturnWert)
 {
  // +++++ Silverlight-Control-Daten holen (fr Test-Control)
  X_ControlArt=X_SilverlightTestControl_Art_SupportedBrowser[X_IndexAufFeld];			// Control-Art
  X_ActiveXControlErzeugen=(X_ControlArt==1);								// true so ActiveX
  X_PlugInKennung=X_SilverlightTestControl_PluginAxtivexKennung_SupportedBrowser[X_IndexAufFeld];	// Plugin-Kennung
  X_ControlCode=X_SilverlightTestControl_HTMLCode_SupportedBrowser[X_IndexAufFeld];			// Control-Code

  // +++++ init Zeiger auf DIV-Container und Test-Control
  X_DIVContainer=null;
  X_TestControl=null;	

  // +++++ Silverlight-Control als Test-Control erzeugen und prfen ob Version laut Funktionsparameter
  //					untersttzt wird
  //	     per try-catch  jede Fehlerart abfangen und Returnwert belegen
  try
  {// ++++++ Test-Control erzeugen

   // ----- ActiveXControl erzeugen
   if(X_ActiveXControlErzeugen)
   {X_TestControl=new ActiveXObject(X_PlugInKennung);}
   else
   {
    // ----- nicht-Windows-Browser kennen nur PlugIn
    //       prfen ob Plugin von Silverlight installiert ist

    X_ReturnWert=(window.navigator.plugins.length>0);
    if(X_ReturnWert){X_ReturnWert=(window.navigator.plugins[X_PlugInKennung]!=null);}
    if(X_ReturnWert)
    {
     // ----- Plugin ist installiert

     // ----- DIV-Container erzeugen (anhngen an document)
     X_DIVContainer=document.createElement("DIV");			// erzeugen
     X_ReturnWert=(X_DIVContainer!=null);
     if(X_ReturnWert)
     {X_DIVContainer=document.body.appendChild(X_DIVContainer);	// anhngen
      X_ReturnWert=(X_DIVContainer!=null);
     }
     if(X_ReturnWert)
     {X_DIVContainer.innerHTML = X_ControlCode;				// wird sofort gerendert
											//	Kind des DIV erzeugen (Test-Control im DIV)
	X_TestControl = X_DIVContainer.childNodes[0];			// einzigste Kind im DIV-Container ist 
											// 	das Test-Control
	// wer will kann das Test-Control auch per createElement() und div_container.appendChild() erzeugen
	//		und desse Attribute per Punktnotation (z.B. zeiger_auf_control_aus_appendchild.type = wert;) fllen
	//	Achtung: Microsoft Explorer bentigt kein getElementID etc., sondern kann mit Zeigern, die
      //			anhand des ID-Attributes implementiert wurden, umgehen: ID-Attributwert ist der Zeiger.
	//			Warnung: ID-Attribut darf in HMTL-Code, der in createElement() verwendet wird,
	//						NICHT kodiert sein (Zeiger laut createElement() verwenden).
      //		   Zeiger, die aus HTML-DOM-Funktionen wie appendChild() resultieren, mssten in jedem
      //			Browser direkt verwendbar sein (ohne Umweg ber getElementID etc.) (im Internet Explorer sowieso).
     }
    }
   }

   // +++++ prfen ob Test-Control erzeugt wurde
   X_ReturnWert=(X_TestControl!=null);

   if(X_ReturnWert)
   {
    // +++++ prfen ob Silverlight-Version supported wird
    X_ReturnWert=X_TestControl.IsVersionSupported(X_Daten_SilverlightControl_Version);

    //        und im Objekt auch merken
    Silverlight.available=X_ReturnWert;

    // +++++ Testobjekt aus Dokument entfernen (nicht bei ActiveX-Control)
    if(!X_ActiveXControlErzeugen){document.body.removeChild(X_DIVContainer);}

    // +++++ Zeigerinit
    X_TestControl=null;
    X_DIVContainer=null;
   }
  }
  catch(e)
  {// +++++ im Fehlerfall (JEDER Art)
   X_ReturnWert=false;
  }
 } // Index gltig

 return X_ReturnWert;
};

// ++++++ auf unerlaubte Kombinationen von Betriebssystem und Browser prfen ++++++++++++++++++++++++++++++++++++
function Y_SilverlightEinsetzbarkeitErmitteln_AufUnerlaubteKombinationBrowserBetriebssystemPruefen()
// bentigt gefllt Silverlight.ua
// Returnwert: wenn true  geliefert so mindestens 1 unerlaubte Kombination erkannt
//      	        false geliefert so keine        unerlaubte Kombination erkannt
// fllt nicht X_SilverlightEinsetzbar
{var X_Flag=false;
 var X_Wert=0;
 var X_Zahler=0;
 var X_OS=Silverlight.ua.OS;
 var X_Browser=Silverlight.ua.Browser;

 // +++++ prfen ob Betriebssystem nicht supported (ist ja auch unerlaubt)
 X_Flag=(X_OS==X_Kennzeichen_NichtSupported);
 // +++++ prfen ob Browser nicht supported (ist ja auch unerlaubt)
 X_Flag= (  X_Flag
          ||(X_Browser==X_Kennzeichen_NichtSupported)
         );
 // +++++ prfen ob unerlaubte Kobmination aus Betriebssystem mit Browser anliegt
 X_Wert=X_UnerlaubteKombination_TitelFeld_SupportedBetriebssystem.length;
 if(X_Wert>0)
 {for(X_Zahler=0;X_Zahler<X_Wert;X_Zahler++)
  {X_Flag= (   X_Flag 
            || (   (X_OS==X_UnerlaubteKombination_TitelFeld_SupportedBetriebssystem[X_Zahler])	// Kombination aus Betriebssystem
                && (X_Browser==X_UnerlaubteKombination_TitelFeld_SupportedBrowser[X_Zahler])	//    mit Browser
               )
           );
  }
 }
 return X_Flag;
};


// ++++++ prfen ob     Silverlight von Betriebsystem UND Browser untersttzt wird ++++++++++++++++++++++++++++++
//			  UND Silverlight-ActiveX- bzw. -Plugin verfgbar ist
//		also ob Silverlight einsetzbar ist
function Y_SilverlightEinsetzbarkeitErmitteln()
// fllt Silverlight.ua
// fllt nicht X_SilverlightEinsetzbar
// liefert true so Silverligth einsetzbar (ob Silverlight-Objekt initialisiert ist, wird nicht beachtet)
{
 var X_Kette1='';
 var X_Kette2='';
 var X_KettenFeld;
 var X_ZaehlerEndWert=0;
 var X_Zaehler=0;
 var X_VersionErkannt=0;
 var X_SupportedHauptVersion=0;
 var X_SupportedUnterVersion=0;
 var X_UserAgentZeiger = window.navigator.userAgent;
 var X_Flag=false;

 // +++++ Silverlight-Objekt-Elemente init auf Annahme, dass
 //				weder erkanntes Betriebssystem
 //				noch  erkannter Browser
 //			von Silverlight untersttzt wird.
 Silverlight.ua=
 {OS: X_Kennzeichen_NichtSupported,
  Browser: X_Kennzeichen_NichtSupported
 };

 // +++++ von Silverlight untersttzte Betriebssystem erkennen und im Silverlight-Objekt merken

 // ----- supported Betriebsysteme vorhanden ?
 X_ZaehlerEndWert=X_KennzeichenFeld_SupportedBetriebssystem.length; 	// ja wenn > 0
 
 // ----- supported Betriebssysteme abklappern
 if(X_ZaehlerEndWert>0)
 {for(X_Zaehler=0;X_Zaehler<X_ZaehlerEndWert;X_Zaehler++)			// Feld-Index
  {
   // ----- ERST auf supported prfen
   X_Kette1=X_KennzeichenFeld_SupportedBetriebssystem[X_Zaehler]; 	// supported Kennung holen

   if(X_UserAgentZeiger.indexOf(X_Kette1)>=0)
   {
    // ----- DANN auf nicht eingeschrnkt supported prfen
    X_Kette1=X_KennzeichenFeld_EingeschraenktSupportedBetriebssystem[X_Zaehler]; 	
												// eingeschrnkt-supported Kennung holen
    if(X_UserAgentZeiger.indexOf(X_Kette1)==-1)
    {
     // ------ supported ohne Einschrnkung
     Silverlight.ua.OS=X_TitelFeld_SupportedBetriebssystem[X_Zaehler];	// Titel merken
    }
   }
  } // for
 }

 // +++++ von Silverlight untersttzte Browser erkennen und im Silverlight-Objekt merken
 //       Achtung: window.navigator.userAgent muss Zeichenkette enthalten in der Form "wxyz"
 //				wobei w 	laut X_Kennung_SupportedBrowser		z.B.  "Firefox/"
 //					x 	fr Hauptversion als Ziffer				z.B.  "2"  oder "20"
 //					y   	laut X_VersionsNummerTrenner  			z.B. "."
 //					z 	fr Unterversion als Ziffer				z.B.  "5"  oder "25"
 //				Die Syntax wird NUR dann geprft, wenn erkannter Browser 
 //					mit Kennung laut navigator.userAgent in X_Kennung_SupportedBrowser hinterlegt ist
 //                       und Hauptversionsummer > 0 in X_Hauptversion_SupportedBrowser.
 //                     Ein Browser, dessen Kennung laut navigator.userAgent  nicht enthalten ist in
 //								     in  X_Kennung_SupportedBrowser
 //					gilt automatisch als nicht supported !


 // ----- prfen ob erkanntes Betriebssystem ohne Einschrnkung supported wird
 if(Silverlight.ua.OS!=X_Kennzeichen_NichtSupported)
 {
  // ----- supported Browser vorhanden ?
  X_ZaehlerEndWert=X_Kennung_SupportedBrowser.length; 		// ja wenn > 0
  
  if(X_ZaehlerEndWert>0)
  {
   // ----- supported Browser abklappern
   for(X_Zaehler=0;X_Zaehler<X_ZaehlerEndWert;X_Zaehler++)			// Feld-Index
   {
    // ----- supported Kennung holen
    //	 an Beispiel Firefox  "Firefox/"
    X_Kette1=X_Kennung_SupportedBrowser[X_Zaehler]; 		// supported Kennung holen

    // ----- und supported Kennung suchen im userAgent-String
    if(X_UserAgentZeiger.indexOf(X_Kette1)>=0)
    {
     // ----- Kennung als supported erkannt (Browser supportbar)
     // 	  Browser muss mit seiner Kennung an o.g. Syntx halten
     //			(ansonsten gilt der Browser als nicht supported)

     // ----- jetzt Titel holen
     X_Kette2=X_Titel_SupportedBrowser[X_Zaehler];

     // ------ supported Hauptversion holen
     X_SupportedHauptVersion=X_Hauptversion_SupportedBrowser[X_Zaehler];

     // ----- supported Hauptversion prfen nur wenn > 0  (== 0 bedeutet immer supported)
     if(X_SupportedHauptVersion>0)
     {
      // ----- Hauptversionsummer erkennen am Beispiel fr Firefox
      // - - - splitten direkt hinter "Firefox/" und Teilketten nach Feld
      //				"Firefox/" wird nicht bernommen
      //				mindestens 1 Feldelement entsteht
      //					alles bis vor "Firefox/"
      //					eventuell alles ab hinter "Firefox/"
      X_KettenFeld=X_UserAgentZeiger.split(X_Kette1);

      // - - - hinter Firefox/ muss die Versionsabgabe laut o.g. Syntax liegen

      // - - - prfen ob Teilkette der Versionsangabe als Feldelemet verfgbar
      if(X_KettenFeld.length>1)							// Lnge ab 1
      {
       // - - - verfgbar, also alles splitten am Trenner laut X_VersionsNummerTrenner und wieder als Feldelemente
	 //				Trenner wird nicht bernommen
       X_KettenFeld=X_KettenFeld[1].split(X_VersionsNummerTrenner);	// Index ab 0

       // - - - Hauptversionsummer liegt vor dem ERSTEN X_VersionsNummerTrenner also im Feldelement mit Index 0
       //					 prfen ob Feldelement der Hauptversionsnummer verfgbar
       if(X_KettenFeld.length>1)							// Lnge ab 1
       {
        // - - - Hauptversion nach numerisch
        X_VersionErkannt = parseInt(X_KettenFeld[0]);				// Index ab 0

        // ----- prfen ob erkannte Hauptversion mindestens die supported Hauptversion
        if(X_VersionErkannt>=X_SupportedHauptVersion)
        {
         // ----- prfen ob identisch mit Hauptversion, denn nur dann wird Unterversion relevant
         if(X_VersionErkannt==X_SupportedHauptVersion)
         {
	    // ------ supported Unterversion holen
     	    X_SupportedUnterVersion=X_Unterversion_SupportedBrowser[X_Zaehler];

          // ------ prfen ob Unterversion > 0 (== 0 bedeutet immer supported)
          if(X_SupportedUnterVersion>0)
          {
           // ----- Unterversiosnummer erkennen am Beispiel fr Firefox
           X_VersionErkannt = parseInt(X_KettenFeld[1]);			// Feldelemente nach dem ERSTEN 
												//   	X_VersionsNummerTrenner nach 
												// numerisch (Unterversion)

           // ----- prfen ob erkannte mindestens die supported Unterversion ist
           if(X_VersionErkannt>=X_SupportedUnterVersion){Silverlight.ua.Browser=X_Kette2;}		
												// supported also Titel merken

          } // supported Unterversion > 0
          else{Silverlight.ua.Browser=X_Kette2;}				// supported Unterversion ist 0
												//		also wird Browser immer supported 
												//		also Titel merken
         } // erkannte Hauptversion ist identisch mit supported Hauptversion
         else{Silverlight.ua.Browser=X_Kette2;}					// erkannte Hautpversion grsser als supported
												//	also Unterversion egal
												//	also Titel merken
        } // erkannte Hauptversion ist mindestens supported Hauptversion
       } // Feldelement der Hauptversionsnummer verfgbar
      } // Teilkette der Versionsangabe als Feldelement verfgbar
     } // supported Hauptversion > 0
     else{Silverlight.ua.Browser=X_Kette2;}					// supported Hauptversion ist 0 
												//		also wird Browser immer supported 
												//		also Titel merken
    } // supported Kennung im userAgent-Sring gefunden: Browser supportbar
   } // for supported Browser abklappern
  } // supported Browser verfgbar
 } // erkanntes Betriebssystem wird ohne Einschrnkung supported


 // ++++++ auf verbotene Kombinationen von Betriebssystem und Browser prfen
 //			(inklusive Prfung auf X_Kennzeichen_NichtSupported)
 //        wenn ja,   dann Silverlight nicht einsetzbar
 //	     wenn nein, dann Silverlight       einsetzbar
 X_Flag=Y_SilverlightEinsetzbarkeitErmitteln_AufUnerlaubteKombinationBrowserBetriebssystemPruefen();
	// bentigt gefllt Silverlight.ua
	// Returnwert: wenn true  geliefert so mindestens 1 unerlaubte Kombination erkannt, also Silverlight nicht einsetzbar
	//      	        false geliefert so keine        unerlaubte Kombination erkannt, also Silverlight       einsetzbar
 return !X_Flag;
};


// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			Silverlight-Init der Daten
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


// +++++ Silverlight-Objekt-Struktur fllen mit Daten +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function Y_SilverlightVerwaltung_Aktivieren_InitUndStart(X_Daten)
// X_Daten wird festgelegt in GrandPiano.js
//			bezglich Elemente-Bezeichner und Werte
// bentigt gefllt X_SilverlightEinsetzbar  true so Silverligth einsetzbar
// aufgerufen von Y_SilverlightVerwaltung_Aktivieren()
{var X_Daten_OBJECT={};
 var X_Daten_PARAM={};
 var X_Index;
 var X_KettenFeld;
 var X_Wert=0;
 var X_Zahler=0;
 var X_Kette='';
 var X_Zeiger;
 var X_Flag=false;
 
 // ++++++ prfen ob Silverlight einsetzbar ist
 if(X_SilverlightEinsetzbar)
 {// +++++ prfen ob Datenstruktur verfgbar
  if(X_Daten!=null)
  {
   // +++++ Daten OBJECT fllen
   //			Es werden auch in OBJECT bentigte Datenelemente aus X_Daten bernommen
   //				wobei Bezeichner der Datenelemente sich mit bernahme ndern knnte
   //			zu OBJECT siehe Y_SilverlightControl_HTMLCode_ermitteln()
   X_Wert=X1_Daten_OBJECT_ElementeBezeichner.length;
   for(X_Zahler=0;X_Zahler<X_Wert;X_Zahler++)
   {// ----- eval-Kette der bernahme bilden
    // zu bernehmendes Datenelement adressieren
    X_Kette='X_Zeiger=X_Daten.' + X1_Daten_OBJECT_ElementeBezeichner[X_Zahler] + ';';
    // und prfen ob existent
    X_Kette+='X_Flag=(X_Zeiger!=null);';
    // und bernehmen
    X_Kette+=('if(X_Flag){X_Daten_OBJECT.' + X1_Daten_OBJECT_ElementeBezeichner[X_Zahler] +  '=X_Zeiger;}');
    // ----- bernehmen
    eval(X_Kette);
   }

   // +++++ Daten PARAM fllen
   //			Es werden nur in PARAM bentigte Datenelemente aus X_Daten bernommen
   //				wobei Bezeichner der Datenelemente sich mit bernahme ndern,
   //			zu PARAM siehe Y_SilverlightControl_HTMLCode_ermitteln()
   X_Wert=X1_Daten_PARAM_ElementeBezeichner.length;
   for(X_Zahler=0;X_Zahler<X_Wert;X_Zahler++)
   {// ----- eval-Kette der bernahme bilden
    // zu bernehmendes Datenelement adressieren
    X_Kette='X_Zeiger=X_Daten.' + X1_Daten_PARAM_ElementeBezeichner[X_Zahler] + ';';
    // und prfen ob existent
    X_Kette+='X_Flag=(X_Zeiger!=null);';
    // und bernehmen
    X_Kette+=('if(X_Flag){X_Daten_PARAM.' + X1_Daten_PARAM_ElementeBezeichner[X_Zahler] +  '=X_Zeiger;}');
    // ----- bernehmen
    eval(X_Kette);

	// Hinweis: Folgendes geht nur, wenn der Index selbst keine Punktnotaion enthlt (da
	//				jeder Punkt einen Unter-Index anzeigt)
	//			X_Daten_PARAM[X1_Daten_PARAM_ElementeBezeichner[X_Zahler]]
	//		    = X_Daten[X1_Daten_PARAM_ElementeBezeichner[X_Zahler]];
   }

   // +++++ Eventhandler, die nicht onLoad oder onError sind, werden mit den Zeigern
   //			aus der DatenStruktur.events nach Daten PARAM bernommen
   // ----- Struktur abklappern
   for (X_Index in X_Daten.events)
   {// ----- wenn     Elemment verfgbar ist
    //            und Bezeichner nicht 'onload'  ist 
    //            und Bezeichner nicht 'onError' ist
    //	Bezeichner laut GrandPiano.js
    if(    X_Daten.events[X_Index]
       && (X_Index != "onLoad")
       && (X_Index != "onError")
      ) 
    {// ----- dann Zeiger des Handlers nach Daten PARAM
     X_Daten_PARAM[X_Index] = X_Daten.events[X_Index];
    }
   }

   // +++++ Verfgbarkeit von Silverlight-ActiveX bzw. -PlugIn ermitteln
   if (Y_SilverlightEinsetzbarkeitErmitteln_AufActiveXbzwPluginPruefen(X1_SilverlightControl_Version)) 
   {
    // +++++ wenn Zhler auf 0 so onUnload-Event-berwachung aktivieren
    //                   > 0   so onUnload-Event            berwachen
    if (Silverlight._silverlightCount == 0)
    {if (window.addEventListener){window.addEventListener("onunload", Y_Window_Eventhandler_OnUnLoad, false);}}
    else{window.attachEvent("onunload",Y_Window_Eventhandler_OnUnLoad);}

    // +++++ Kennung der Eventhandler erzeugen und in Kopie-Dstenstruktur Properties merken fr
    //			Y_Window_Eventhandler_OnUnLoad
    // ----- variablen Teil der Kennung bilden
    X_Wert = Silverlight._silverlightCount++;
    X_Kette=X_Wert.toString();
    // ----- Kennung merken
    X_Daten_PARAM.onLoad  = X_WindowEventhandler_Load_Kennung  + X_Kette;
    X_Daten_PARAM.onError = X_WindowEventhandler_Error_Kennung + X_Kette;

    // +++++ und Eventhandler an window bergeben unter gerade erstellter Kennung
    //		Hinweis: Zeiger Lschen per Y_Window_Eventhandler_OnUnLoad()
    // ----- onLoad
    window[X_Daten_PARAM.onLoad] = function(X_FehlerObjekt) 
    {
     if (X_Daten.events.onLoad) 
     {X_Daten.events.onLoad(document.getElementById(X_Daten_OBJECT.id),
				    X_Daten.context,X_FehlerObjekt);
				   }
    };
    // ----- onError
    window[X_Daten_PARAM.onError] = function(e, X_FehlerObjekt)
    {
     if (X_Daten.events.onError)
     {X_Daten.events.onError(e, X_FehlerObjekt);}
     else
     {Y_Silverlight_EventHandler_Standard(e, X_FehlerObjekt);}
    };

    // +++++ Silverlight-HTML-Code ermitteln (OBJECT mit PARAM)
    X_Kette = Y_SilverlightControl_HTMLCode_ermitteln(X_Daten_OBJECT, X_Daten_PARAM);
   }
   else{X_Kette = Y_SilverlightOnlineInstallControl_HTMLCode_ermitteln(X_Daten);}
				// nicht verfgbar also Download der Silverlight-Variante
				//	OBJECT ohne PARAM

   // +++++ wenn Eltern existieren, dann HTML-Code in den Eltern ablegen (Eltern neu rendern)
   if (X_Daten.parentElement){X_Daten.parentElement.innerHTML = X_Kette;}
   else{return X_Kette;}

  } // Datenstruktur verfgbar
 } // Silverlight einsetzbar
};

// +++++ Silverlight-Objekt erzeugen und Struktur fllen mit Daten ++++++++++++++++++++++++++++++++++++++++++++++
function Y_SilverlightVerwaltung_Aktivieren(X_Daten)
// X_Daten wird festgelegt in GrandPiano.js
//			bezglich Elemente-Bezeichner und Werte
// bentigt gefllt X_SilverlightEinsetzbar  true so Silverligth einsetzbar
{var X_DatenRette;
 var X_ReturnWert;
 // ++++++ prfen ob Silverlight einsetzbar ist
 if(X_SilverlightEinsetzbar)
 {if(X_Daten!=null)
  {X_DatenRette = X_Daten;
   X_ReturnWert = Y_SilverlightVerwaltung_Aktivieren_InitUndStart(X_DatenRette);
   if (X_DatenRette.parentElement==null){return X_ReturnWert;}
  }
 }
};


// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			Silverlight-Init und Start der Silverlight-Verwaltung
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// +++++ Silverlight-Objekt Silverlight als Unterobjekt von window prfen
var X_SilverlightEinsetzbar=false;		// true, so Browser und Betriebssystem passen zu Silverlight
							//			und Silverlight ist als ActiveX bzw. Plugin verfgbar
							//	     ob Silverlight-Objekt initilalisert ist, wird nicht erfasst

// +++++ Silverlight komplett erzeugen
function createSilverlight()	// aufgerufen in index.html
// liefert true wenn Silverlight erfolgreich erzeugt und aktiviert wurde
{var EventVerwaltung;	// Eventverwaltung-Objekt
 var X_EventDelegate;	// Funktionszeiger auf Routine, die Eventhandler einbindet
 var X_Kette='errorHandle';

 // +++++ Annahme: Silverlight nicht einsetzbar
 X_SilverlightEinsetzbar=false;

 // +++++ Sys und Silverlight je als Objekt von window leer erzeugen
 if(!window.Sys){window.Sys = {};}
 if(!window.Silverlight){window.Silverlight = {};}

 // +++++ Silverlight-Eventhandler in aktive Silverlight-Eventverwaltung einbinden
 //	   wird auch in anderen js-Dateien bentigt
 Silverlight.createDelegate = function(EventVerwaltungInstanz, Handler_SilverlightEvent)
 {return function()
  {return Handler_SilverlightEvent.apply(EventVerwaltungInstanz, arguments);}
					// arguments   Collection der Funktionsargumente (Parameter)
 }

 //  +++++ Silverlight-Schnittstellen init
 Silverlight._silverlightCount=0;
 Silverlight.ua				=null;
 Silverlight.available			=false;
 Silverlight.fwlinkRoot			=X_SilverlightDownloadUrl;
 Silverlight.default_error_handler	=Y_Silverlight_EventHandler_Standard;
 Silverlight.followFWLink		=Y_DownloadLink_OnClick;
 Silverlight.__cleanup 			=Y_Window_Eventhandler_OnUnLoad;
 Silverlight.buildHTML 			=Y_SilverlightControl_HTMLCode_ermitteln; 
 Silverlight.buildPromptHTML 		=Y_SilverlightOnlineInstallControl_HTMLCode_ermitteln; 
 Silverlight.isInstalled 		=Y_SilverlightEinsetzbarkeitErmitteln_AufActiveXbzwPluginPruefen; 
 Silverlight.detectUserAgent		=Y_SilverlightEinsetzbarkeitErmitteln;
		// fllt Silverlight.ua
		// fllt nicht X_SilverlightEinsetzbar
		// liefert true so Silverligth einsetzbar (ob Silverlight-Objekt initialisiert ist,
		// 							wird nicht beachtet)
 Silverlight.supportedUserAgent     =
                                Y_SilverlightEinsetzbarkeitErmitteln_AufUnerlaubteKombinationBrowserBetriebssystemPruefen;
		// bentigt gefllt Silverlight.ua
		// Returnwert: wenn true  geliefert so mindestens 1 unerlaubte Kombination erkannt
		//      	        false geliefert so keine        unerlaubte Kombination erkannt
		// fllt nicht X_SilverlightEinsetzbar
 Silverlight.createObject           =Y_SilverlightVerwaltung_Aktivieren_InitUndStart;
					// aufgerufen von Y_SilverlightVerwaltung_Aktivieren;
 Silverlight.createObjectEx         =Y_SilverlightVerwaltung_Aktivieren; 

 // ++++++ prfen ob     Silverlight von Betriebsystem UND Browser untersttzt wird
 //			  UND Silverlight-ActiveX- bzw. -Plugin verfgbar ist
 //		   also ob Silverlight einsetzbar ist
 //          (ob Silverlight-Objekt initialisiert ist, wird nicht beachtet)
 X_SilverlightEinsetzbar=Y_SilverlightEinsetzbarkeitErmitteln();
		// fllt Silverlight.ua
		// fllt nicht X_SilverlightEinsetzbar
		// liefert true so Silverligth einsetzbar (ob Silverlight-Objekt initialisiert ist,
		// 							wird nicht beachtet)

 if(X_SilverlightEinsetzbar)
 {// +++++ Eventverwaltung erzeugen und starten
  //		X1_GrandPiano erzeugt in GrandPiano.js
  EventVerwaltung = new X1_GrandPiano.EventVerwaltungInstanzieren();	
						// aus GrandPiano.js

  // +++++ DANN Delegate der Eventverwaltung erzeugen
  X_EventDelegate=Silverlight.createDelegate(EventVerwaltung, EventVerwaltung.Handler_SilverlightEvent_onLoad);
						// EventVerwaltung.Handler_SilverlightEvent_onLoad laut GrandPiano.js
 
  // +++++ DANN init der Pflichtelemente der Silverlight-Daten
  X1_SilverlightDaten[X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_parentElement_Index]]
			= document.getElementById(X1_SilverlightControlHost_ID); 	// Zeiger auf DIV-Container aus index.html;
													// parenElement
  // event wurde bereits als Array() erzeugt
  X1_SilverlightDaten[X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_events_Index]]
 	               [X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_onError_Index]]=X_Kette;
													// entspricht events.onError
  X1_SilverlightDaten[X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_events_Index]]
	               [X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_onLoad_Index]]=
										X_EventDelegate;	// enstspricht events.onLoad

  // +++++ DANN Silverlight-Objekt erzeugen und Animation starten
  Silverlight.createObjectEx(X1_SilverlightDaten);
 }
 return X_SilverlightEinsetzbar;
}
